- Cdigo de los funcionarios que slo registren horas a partir del 1/1/2000.

SELECT cod_func
FROM PERSONAL P
WHERE NOT EXISTS (SELECT * 
		  FROM REGISTRO_HORAS R
		  WHERE P.cod_func = R.cod_func AND
			R.fecha < '1/1/2000' 
		 );

Funcionarios tal que no existe una tupla en registro_horas de ese funcionario
con fecha menor al 2000.


SELECT cod_func
FROM PERSONAL
WHERE cod_func NOT IN (	SELECT cod_func 
			FROM REGISTRO_HORAS 
			WHERE fecha < '1/1/2000' 
	     	      ); 

Funcionarios que no estan dentro del conjunto de funcionarios que registraron
horas con fecha menor al 2000.

-----------------------------------------------------------------------

- Cdigo de los funcionarios que no estn asignados a proyectos del tipo 'Desarrollo'.


SELECT cod_func
FROM PERSONAL P
WHERE NOT EXISTS (SELECT * 
		  FROM ASIGNACION A JOIN TAREAS T ON A.cod_tarea = T.cod_tarea
		  WHERE P.cod_func = A.cod_func AND
			T.tipo = 'Desarrollo'
		 );

SELECT cod_func
FROM PERSONAL
WHERE cod_func NOT IN (	SELECT cod_func 
			FROM ASIGNACION A JOIN TAREAS T ON A.cod_tarea = T.cod_tarea
			WHERE T.tipo = 'Desarrollo'
	     	      ); 


-----------------------------------------------------------------------
Cdigo de los proyectos en los que todas las personas asignadas al mismo ingresaron el ao $2010$, verificando que tengan personas asignadas.

	Para verificar que el proyecto tenga personas asignadas.
	a) Como simplemente se necesita el cod_proy se puede buscar directamente en ASIGNACION y all implicitamente estamos buscando sobre los proyectos con personas asignadas.

		SELECT cod_proy
		FROM ASIGNACION 

	b) Hacer un join de PROYECTOS con ASIGNACION para que elimine los proyectos sin personas asignadas

		SELECT cod_proy
		FROM PROYECTOS P NATURAL JOIN ASIGNACION A

	c) Utilizar una condicin EXISTS en el WHERE

		SELECT cod_proy
		FROM PROYECTOS P
		WHERE EXISTS ( --Funcionarios asignados al proyecto
				SELECT *
				FROM ASIGNACION A
				WHERE P.cod_proy = A.cod_proy 
			     )

Consideremos la siguiente consulta, donde (CODIGO) corresponde a un cdigo de proyecto:
-- Funcionarios que ingresaron al proyecto A.cod_proy en un ao diferente a 2010
SELECT * 
FROM ASIGNACION B JOIN PERSONAL P ON B.cod_func = P.cod_func
WHERE (CODIGO) = B.cod_proy AND P.fecha_ingreso <> '2010'

Utilicemos ambas consultas combinadas para resolver la consulta original. Utilicemos la opcin (a) por simplicidad (pero pueden ser utilizadas cualquiera de las otras estrategias).

SELECT cod_proy
FROM ASIGNACION A    -- Al buscarlo en Asignacin implicitamente indicamos que exista al menos una persona asignada
WHERE NOT EXISTS ( -- Funcionarios que ingresaron al proyecto A.cod_proy en un ao diferente a 2010
		   SELECT * 
		   FROM ASIGNACION B JOIN PERSONAL P ON B.cod_func = P.cod_func
		   WHERE A.cod_proy = B.cod_proy AND 
			 P.fecha_ingreso <> '2010'
		 );

